//-----------------------------------------------------------
//Sherman 75mm cannon projectile
//Shell bullet flying, incoming sound when it get near you and explode when it
//hit you hahahahaha
//By XenoAisam
//-----------------------------------------------------------
class mmProjectile extends Projectile;

#exec OBJ LOAD FILE=..\Sounds\VMVehicleSounds-S.uax
#exec AUDIO IMPORT FILE=C:\Voice\Incoming75mm.wav NAME=Incoming75mm
#exec AUDIO IMPORT FILE=C:\Voice\Explosion75mm.WAV NAME=Explode75mm

var Emitter SmokeTrailEffect;
var bool bHitWater;
var Effects Corona;
var vector Dir;

simulated function Destroyed()
{
	if ( SmokeTrailEffect != None )
			SmokeTrailEffect.Kill();
		if ( Corona != None )
			Corona.Destroy();
	Super.Destroyed();
}

simulated function PostBeginPlay()
{
	if ( Level.NetMode != NM_DedicatedServer)
	{
		SmokeTrailEffect = Spawn(class'mmcannon.mmfireTrailEffect',self);
		Corona = Spawn(class'mmcannon.mmCorona',self);
	}

	Dir = vector(Rotation);
	Velocity = speed * Dir;
	if (PhysicsVolume.bWaterVolume)
	{
		bHitWater = True;
		Velocity=0.6*Velocity;
	}
    if ( Level.bDropDetail )
	{
		bDynamicLight = false;
		LightType = LT_None;
	}
	Super.PostBeginPlay();
}

simulated function Landed( vector HitNormal )
{
	Explode(Location,HitNormal);
}

simulated function ProcessTouch (Actor Other, Vector HitLocation)
{
	if ( (Other != instigator) && (!Other.IsA('Projectile') || Other.bProjTarget) )
		Explode(HitLocation,Vect(0,0,1));
}

function BlowUp(vector HitLocation)
{
	HurtRadius(Damage, DamageRadius, MyDamageType, MomentumTransfer, HitLocation );
	MakeNoise(1.0);
}

simulated function Explode(vector HitLocation, vector HitNormal)
{
	PlaySound(sound'Explode75mm',,5.5*TransientSoundVolume);
    if ( EffectIsRelevant(Location,false) )
    {
    	Spawn(class'ONSTankHitRockEffect',,,HitLocation + HitNormal*16, rotator(HitNormal) + rot(-16384,0,0));
		if ( (ExplosionDecal != None) && (Level.NetMode != NM_DedicatedServer) )
			Spawn(ExplosionDecal,self,,Location, rotator(-HitNormal));
    }

	BlowUp(HitLocation);
	Destroy();
}

defaultproperties
{
    Speed=9000.0
    MaxSpeed=9000.0
    MomentumTransfer=125000
    Damage=100.0
    DamageRadius=660.0
    AmbientSound=sound'Incoming75mm'
    SoundVolume=255
    SoundRadius=1000
    TransientSoundVolume=1.0
    TransientSoundRadius=1000
    bFullVolume=True
    MyDamageType=class'mmcannon.DamType75mmShell'
    ExplosionDecal=class'ONSRocketScorch'
    RemoteRole=ROLE_SimulatedProxy
    LifeSpan=1.2
    DrawType=DT_StaticMesh
    AmbientGlow=96
    bUnlit=True
    bBounce=false
    bFixedRotationDir=True
    RotationRate=(Roll=50000)
    DesiredRotation=(Roll=30000)
    ForceType=FT_Constant
    ForceScale=5.0
    ForceRadius=100.0
    bCollideWorld=true
    FluidSurfaceShootStrengthMod=10.0
}
